# "socket" is the name for opening connections with other machines
import socket
import struct

dest_name = "www.stetson.edu"
# convert the name to its IP (look up in DNS)
dest_addr = socket.gethostbyname(dest_name)
# use port 33434 since that's known as a "traceroute port"
port = 33434

# set up variables for protocols
icmp = socket.getprotobyname("icmp")
udp = socket.getprotobyname("udp")

# establish the receiving (response) socket
recv_socket = socket.socket(socket.AF_INET, socket.SOCK_RAW, icmp)
send_socket = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, udp)

# set the TTL value
ttl = 4
send_socket.setsockopt(socket.SOL_IP, socket.IP_TTL, ttl)

# Set the GNU time value struct (seconds, microseconds)
timeout = struct.pack("ll", 2, 0)

# Set the receiving socket timeout
recv_socket.setsockopt(socket.SOL_SOCKET, socket.SO_RCVTIMEO, timeout)

# set up receiving socket on the port
recv_socket.bind(("", port))

# send blank data to destination
send_socket.sendto(str.encode(""), (dest_addr, port))
try:
    # wait to receive response from router that gave up (TTL dropped to 0)
    _, curr_addr = recv_socket.recvfrom(512)
    #print(_)
    #print(curr_addr)
    # try to get DNS name from IP
    curr_name = socket.gethostbyaddr(curr_addr[0])
    print(curr_name)
except:
    print("***")
    
send_socket.close()
recv_socket.close()
